<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (137)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="fetch-api">Fetch API</h1>
    <p>So far, we know quite a bit about <code>fetch</code>.</p>
    <p>Let’s see the rest of API, to cover all its abilities.</p>
    <pre
      class="smart"
    ><code>Please note: most of these options are used rarely. You may skip this chapter and still use `fetch` well.

Still, it&#39;s good to know what `fetch` can do, so if the need arises, you can return and read the details.</code></pre>
    <p>
      Here’s the full list of all possible <code>fetch</code> options with their
      default values (alternatives in comments):
    </p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="kw">let</span> promise <span class="op">=</span> <span class="at">fetch</span>(url<span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-2" title="2">  <span class="dt">method</span><span class="op">:</span> <span class="st">&quot;GET&quot;</span><span class="op">,</span> <span class="co">// POST, PUT, DELETE, etc.</span></a>
<a class="sourceLine" id="cb2-3" title="3">  <span class="dt">headers</span><span class="op">:</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-4" title="4">    <span class="co">// the content type header value is usually auto-set</span></a>
<a class="sourceLine" id="cb2-5" title="5">    <span class="co">// depending on the request body</span></a>
<a class="sourceLine" id="cb2-6" title="6">    <span class="st">&quot;Content-Type&quot;</span><span class="op">:</span> <span class="st">&quot;text/plain;charset=UTF-8&quot;</span></a>
<a class="sourceLine" id="cb2-7" title="7">  <span class="op">},</span></a>
<a class="sourceLine" id="cb2-8" title="8">  <span class="dt">body</span><span class="op">:</span> <span class="kw">undefined</span> <span class="co">// string, FormData, Blob, BufferSource, or URLSearchParams</span></a>
<a class="sourceLine" id="cb2-9" title="9">  <span class="dt">referrer</span><span class="op">:</span> <span class="st">&quot;about:client&quot;</span><span class="op">,</span> <span class="co">// or &quot;&quot; to send no Referer header,</span></a>
<a class="sourceLine" id="cb2-10" title="10">  <span class="co">// or an url from the current origin</span></a>
<a class="sourceLine" id="cb2-11" title="11">  <span class="dt">referrerPolicy</span><span class="op">:</span> <span class="st">&quot;no-referrer-when-downgrade&quot;</span><span class="op">,</span> <span class="co">// no-referrer, origin, same-origin...</span></a>
<a class="sourceLine" id="cb2-12" title="12">  <span class="dt">mode</span><span class="op">:</span> <span class="st">&quot;cors&quot;</span><span class="op">,</span> <span class="co">// same-origin, no-cors</span></a>
<a class="sourceLine" id="cb2-13" title="13">  <span class="dt">credentials</span><span class="op">:</span> <span class="st">&quot;same-origin&quot;</span><span class="op">,</span> <span class="co">// omit, include</span></a>
<a class="sourceLine" id="cb2-14" title="14">  <span class="dt">cache</span><span class="op">:</span> <span class="st">&quot;default&quot;</span><span class="op">,</span> <span class="co">// no-store, reload, no-cache, force-cache, or only-if-cached</span></a>
<a class="sourceLine" id="cb2-15" title="15">  <span class="dt">redirect</span><span class="op">:</span> <span class="st">&quot;follow&quot;</span><span class="op">,</span> <span class="co">// manual, error</span></a>
<a class="sourceLine" id="cb2-16" title="16">  <span class="dt">integrity</span><span class="op">:</span> <span class="st">&quot;&quot;</span><span class="op">,</span> <span class="co">// a hash, like &quot;sha256-abcdef1234567890&quot;</span></a>
<a class="sourceLine" id="cb2-17" title="17">  <span class="dt">keepalive</span><span class="op">:</span> <span class="kw">false</span><span class="op">,</span> <span class="co">// true</span></a>
<a class="sourceLine" id="cb2-18" title="18">  <span class="dt">signal</span><span class="op">:</span> <span class="kw">undefined</span><span class="op">,</span> <span class="co">// AbortController to abort request</span></a>
<a class="sourceLine" id="cb2-19" title="19">  <span class="dt">window</span><span class="op">:</span> window <span class="co">// null</span></a>
<a class="sourceLine" id="cb2-20" title="20"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>An impressive list, right?</p>
    <p>
      We fully covered <code>method</code>, <code>headers</code> and
      <code>body</code> in the chapter
      <a href="info:fetch" class="uri">info:fetch</a>.
    </p>
    <p>
      The <code>signal</code> option is covered in
      <a href="info:fetch-abort" class="uri">info:fetch-abort</a>.
    </p>
    <p>Now let’s explore the remaining capabilities.</p>
    <h2 id="referrer-referrerpolicy">referrer, referrerPolicy</h2>
    <p>
      These options govern how <code>fetch</code> sets the HTTP
      <code>Referer</code> header.
    </p>
    <p>
      Usually that header is set automatically and contains the url of the page
      that made the request. In most scenarios, it’s not important at all,
      sometimes, for security purposes, it makes sense to remove or shorten it.
    </p>
    <p>
      <strong
        >The <code>referrer</code> option allows to set any
        <code>Referer</code> (within the current origin) or remove it.</strong
      >
    </p>
    <p>To send no referer, set an empty string:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="at">fetch</span>(<span class="st">&#39;/page&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb3-3" title="3">  <span class="dt">referrer</span><span class="op">:</span> <span class="st">&quot;&quot;</span> <span class="co">// no Referer header</span></a>
<a class="sourceLine" id="cb3-4" title="4"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="ss">}</span><span class="sc">)</span><span class="ss">;</span></a></code></pre>
    </div>
    <p>To set another url within the current origin:</p>
    <div class="sourceCode" id="cb4">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb4-1" title="1"><span class="at">fetch</span>(<span class="st">&#39;/page&#39;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb4-2" title="2">  <span class="co">// assuming we&#39;re on https://javascript.info</span></a>
<a class="sourceLine" id="cb4-3" title="3">  <span class="co">// we can set any Referer header, but only within the current origin</span></a>
<a class="sourceLine" id="cb4-4" title="4"><span class="op">*!*</span></a>
<a class="sourceLine" id="cb4-5" title="5">  <span class="dt">referrer</span><span class="op">:</span> <span class="st">&quot;https://javascript.info/anotherpage&quot;</span></a>
<a class="sourceLine" id="cb4-6" title="6"><span class="op">*</span><span class="ss">/!</span><span class="sc">*</span></a>
<a class="sourceLine" id="cb4-7" title="7"><span class="ss">}</span><span class="sc">)</span><span class="ss">;</span></a></code></pre>
    </div>
    <p>
      <strong
        >The <code>referrerPolicy</code> option sets general rules for
        <code>Referer</code>.</strong
      >
    </p>
    <p>Requests are split into 3 types:</p>
    <ol type="1">
      <li>Request to the same origin.</li>
      <li>Request to another origin.</li>
      <li>Request from HTTPS to HTTP (from safe to unsafe protocol).</li>
    </ol>
    <p>
      Unlike the <code>referrer</code> option that allows to set the exact
      <code>Referer</code> value, <code>referrerPolicy</code> tells the browser
      general rules for each request type.
    </p>
    <p>
      Possible values are described in the
      <a href="https://w3c.github.io/webappsec-referrer-policy/"
        >Referrer Policy specification</a
      >:
    </p>
    <ul>
      <li>
        <strong><code>"no-referrer-when-downgrade"</code></strong> – the default
        value: full <code>Referer</code> is always sent, unless we send a
        request from HTTPS to HTTP (to the less secure protocol).
      </li>
      <li>
        <strong><code>"no-referrer"</code></strong> – never send
        <code>Referer</code>.
      </li>
      <li>
        <strong><code>"origin"</code></strong> – only send the origin in
        <code>Referer</code>, not the full page URL, e.g. only
        <code>http://site.com</code> instead of
        <code>http://site.com/path</code>.
      </li>
      <li>
        <strong><code>"origin-when-cross-origin"</code></strong> – send the full
        <code>Referer</code> to the same origin, but only the origin part for
        cross-origin requests (as above).
      </li>
      <li>
        <strong><code>"same-origin"</code></strong> – send the full
        <code>Referer</code> to the same origin, but no <code>Referer</code> for
        cross-origin requests.
      </li>
      <li>
        <strong><code>"strict-origin"</code></strong> – send only the origin,
        not the <code>Referer</code> for HTTPS→HTTP requests.
      </li>
      <li>
        <strong><code>"strict-origin-when-cross-origin"</code></strong> – for
        same-origin send the full <code>Referer</code>, for cross-origin send
        only the origin, unless it’s HTTPS→HTTP request, then send nothing.
      </li>
      <li>
        <strong><code>"unsafe-url"</code></strong> – always send the full url in
        <code>Referer</code>, even for HTTPS→HTTP requests.
      </li>
    </ul>
    <p>Here’s a table with all combinations:</p>
    <table>
      <thead>
        <tr class="header">
          <th>Value</th>
          <th>To same origin</th>
          <th>To another origin</th>
          <th>HTTPS→HTTP</th>
        </tr>
      </thead>
      <tbody>
        <tr class="odd">
          <td><code>"no-referrer"</code></td>
          <td>-</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr class="even">
          <td>
            <code>"no-referrer-when-downgrade"</code> or
            <code>""</code> (default)
          </td>
          <td>full</td>
          <td>full</td>
          <td>-</td>
        </tr>
        <tr class="odd">
          <td><code>"origin"</code></td>
          <td>origin</td>
          <td>origin</td>
          <td>origin</td>
        </tr>
        <tr class="even">
          <td><code>"origin-when-cross-origin"</code></td>
          <td>full</td>
          <td>origin</td>
          <td>origin</td>
        </tr>
        <tr class="odd">
          <td><code>"same-origin"</code></td>
          <td>full</td>
          <td>-</td>
          <td>-</td>
        </tr>
        <tr class="even">
          <td><code>"strict-origin"</code></td>
          <td>origin</td>
          <td>origin</td>
          <td>-</td>
        </tr>
        <tr class="odd">
          <td><code>"strict-origin-when-cross-origin"</code></td>
          <td>full</td>
          <td>origin</td>
          <td>-</td>
        </tr>
        <tr class="even">
          <td><code>"unsafe-url"</code></td>
          <td>full</td>
          <td>full</td>
          <td>full</td>
        </tr>
      </tbody>
    </table>
    <p>
      Let’s say we have an admin zone with a URL structure that shouldn’t be
      known from outside of the site.
    </p>
    <p>
      If we send a <code>fetch</code>, then by default it always sends the
      <code>Referer</code> header with the full url of our page (except when we
      request from HTTPS to HTTP, then no <code>Referer</code>).
    </p>
    <p>
      E.g. <code>Referer: https://javascript.info/admin/secret/paths</code>.
    </p>
    <p>
      If we’d like other websites know only the origin part, not the URL-path,
      we can set the option:
    </p>
    <div class="sourceCode" id="cb5">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb5-1" title="1"><span class="at">fetch</span>(<span class="st">&quot;https://another.com/page&quot;</span><span class="op">,</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb5-2" title="2">  <span class="co">// ...</span></a>
<a class="sourceLine" id="cb5-3" title="3">  <span class="dt">referrerPolicy</span><span class="op">:</span> <span class="st">&quot;origin-when-cross-origin&quot;</span><span class="op">,</span> <span class="co">// Referer: https://javascript.info</span></a>
<a class="sourceLine" id="cb5-4" title="4"><span class="op">}</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      We can put it to all <code>fetch</code> calls, maybe integrate into
      JavaScript library of our project that does all requests and uses
      <code>fetch</code> inside.
    </p>
    <p>
      Its only difference compared to the default behavior is that for requests
      to another origin <code>fetch</code> sends only the origin part of the URL
      (e.g. <code>https://javascript.info</code>, without path). For requests to
      our origin we still get the full <code>Referer</code> (maybe useful for
      debugging purposes).
    </p>
    <p>
      ``<code>smart header="Referrer policy is not only for</code>fetch<code
        >" Referrer policy, described in the
        [specification](https://w3c.github.io/webappsec-referrer-policy/), is
        not just for</code
      >fetch`, but more global.
    </p>
    <p>
      In particular, it’s possible to set the default policy for the whole page
      using the <code>Referrer-Policy</code> HTTP header, or per-link, with
      <code>&lt;a rel="noreferrer"&gt;</code>.
    </p>
    <pre><code>
## mode

The `mode` option is a safe-guard that prevents occasional cross-origin requests:

- **`&quot;cors&quot;`** -- the default, cross-origin requests are allowed, as described in &lt;info:fetch-crossorigin&gt;,
- **`&quot;same-origin&quot;`** -- cross-origin requests are forbidden,
- **`&quot;no-cors&quot;`** -- only safe cross-origin requests are allowed.

This option may be useful when the URL for `fetch` comes from a 3rd-party, and we want a &quot;power off switch&quot; to limit cross-origin capabilities.

## credentials

The `credentials` option specifies whether `fetch` should send cookies and HTTP-Authorization headers with the request.

- **`&quot;same-origin&quot;`** -- the default, don&#39;t send for cross-origin requests,
- **`&quot;include&quot;`** -- always send, requires `Accept-Control-Allow-Credentials` from cross-origin server in order for JavaScript to access the response, that was covered in the chapter &lt;info:fetch-crossorigin&gt;,
- **`&quot;omit&quot;`** -- never send, even for same-origin requests.

## cache

By default, `fetch` requests make use of standard HTTP-caching. That is, it respects the `Expires` and `Cache-Control` headers, sends `If-Modified-Since` and so on. Just like regular HTTP-requests do.

The `cache` options allows to ignore HTTP-cache or fine-tune its usage:

- **`&quot;default&quot;`** -- `fetch` uses standard HTTP-cache rules and headers,
- **`&quot;no-store&quot;`** -- totally ignore HTTP-cache, this mode becomes the default if we set a header `If-Modified-Since`, `If-None-Match`, `If-Unmodified-Since`, `If-Match`, or `If-Range`,
- **`&quot;reload&quot;`** -- don&#39;t take the result from HTTP-cache (if any), but populate the cache with the response (if the response headers permit this action),
- **`&quot;no-cache&quot;`** -- create a conditional request if there is a cached response, and a normal request otherwise. Populate HTTP-cache with the response,
- **`&quot;force-cache&quot;`** -- use a response from HTTP-cache, even if it&#39;s stale. If there&#39;s no response in HTTP-cache, make a regular HTTP-request, behave normally,
- **`&quot;only-if-cached&quot;`** -- use a response from HTTP-cache, even if it&#39;s stale. If there&#39;s no response in HTTP-cache, then error. Only works when `mode` is `&quot;same-origin&quot;`.

## redirect

Normally, `fetch` transparently follows HTTP-redirects, like 301, 302 etc.

The `redirect` option allows to change that:

- **`&quot;follow&quot;`** -- the default, follow HTTP-redirects,
- **`&quot;error&quot;`** -- error in case of HTTP-redirect,
- **`&quot;manual&quot;`** -- allows to process HTTP-redirects manually. In case of redirect, we&#39;ll get a special response object, with `response.type=&quot;opaqueredirect&quot;` and zeroed/empty status and most other properies.

## integrity

The `integrity` option allows to check if the response matches the known-ahead checksum.

As described in the [specification](https://w3c.github.io/webappsec-subresource-integrity/), supported hash-functions are SHA-256, SHA-384, and SHA-512, there might be others depending on the browser.

For example, we&#39;re downloading a file, and we know that it&#39;s SHA-256 checksum is &quot;abcdef&quot; (a real checksum is longer, of course).

We can put it in the `integrity` option, like this:

```js
fetch(&#39;http://site.com/file&#39;, {
  integrity: &#39;sha256-abcdef&#39;
});</code></pre>
    <p>
      Then <code>fetch</code> will calculate SHA-256 on its own and compare it
      with our string. In case of a mismatch, an error is triggered.
    </p>
    <h2 id="keepalive">keepalive</h2>
    <p>
      The <code>keepalive</code> option indicates that the request may “outlive”
      the webpage that initiated it.
    </p>
    <p>
      For example, we gather statistics on how the current visitor uses our page
      (mouse clicks, page fragments he views), to analyze and improve the user
      experience.
    </p>
    <p>
      When the visitor leaves our page – we’d like to save the data to our
      server.
    </p>
    <p>We can use the <code>window.onunload</code> event for that:</p>
    <p>
      <code
        >js run window.onunload = function() { fetch('/analytics', { method:
        'POST', body: "statistics", *!* keepalive: true */!* }); };</code
      >
    </p>
    <p>
      Normally, when a document is unloaded, all associated network requests are
      aborted. But the <code>keepalive</code> option tells the browser to
      perform the request in the background, even after it leaves the page. So
      this option is essential for our request to succeed.
    </p>
    <p>It has a few limitations:</p>
    <ul>
      <li>
        We can’t send megabytes: the body limit for
        <code>keepalive</code> requests is 64KB.
        <ul>
          <li>
            If we need to gather a lot of statistics about the visit, we should
            send it out regularly in packets, so that there won’t be a lot left
            for the last <code>onunload</code> request.
          </li>
          <li>
            This limit applies to all <code>keepalive</code> requests together.
            In other words, we can perform multiple
            <code>keepalive</code> requests in parallel, but the sum of their
            body lengths should not exceed 64KB.
          </li>
        </ul>
      </li>
      <li>
        We can’t handle the server response if the document is unloaded. So in
        our example <code>fetch</code> will succeed due to
        <code>keepalive</code>, but subsequent functions won’t work.
        <ul>
          <li>
            In most cases, such as sending out statistics, it’s not a problem,
            as the server just accepts the data and usually sends an empty
            response to such requests.
          </li>
        </ul>
      </li>
    </ul>
  </body>
</html>
